#if !defined INTEGRALHISTOGRAM
#define INTEGRALHISTOGRAM

#include <stdio.h>
#include <math.h>
#include <string.h>
#include "cv.h"      // include core library interface
#include "cxcore.h"   
#include "highgui.h" // include GUI library interface

#define ORIENTGRAD_DNUM4_			001
#define TEXTONS_SC12_GDORDER2_		002

void ilIntegralBlockHistOrig(const CvArr* timgarr, const CvArr* wimgarr, CvMat** ihist, int nc, int bxsz, int bysz);
void ilIntegralBlockHist(const CvArr* timgarr, const CvArr* wimgarr, CvMat** ihist, int nc, double bxsz, double bysz);

void ilClassifyImagePixels(const CvArr* srcarr, CvArr* timgarr, CvArr* wimgarr, CvArr* cmeansnormarr, int pixclasstype);
void ilTextonClassifySC12GDO2(const CvArr* srcarr, CvArr* textonsarr, CvArr* weightsarr, CvArr *cmeansnormarr);
void ilOrientGradClassifyD4(const CvArr* srcarr, CvArr* orientarr, CvArr* weightarr);
void ilOrientGradClassifyD4Project(const CvArr* cmeansnorm, const CvArr* data, CvArr* cdata);
#endif